#LudumDare Animal Crossing game fun times happyness
#Superdisk fun times

import pygame
from pygame.locals import *
import tune
import picture
import chips
from copy import copy
import glove
from time import sleep
import cursor
import civilian as civmodule
import os
import pygame._view
import sys

tv = pygame.display.set_mode((255, 255), DOUBLEBUF | HWSURFACE)
pygame.init()


def pickblock():
    tv.fill((38, 127, 0))
    tv.blit(picture.pictures.terminal.render("Pick a tile", False, (0, 0, 0)), (89, 40))

    tv.blit(picture.pictures.grass, (64, 64)); grassrect = pygame.Rect(64, 64, 16, 16)
    tv.blit(picture.pictures.dirt, (64, 85)); dirtrect = pygame.Rect(64, 85, 16, 16)
    tv.blit(picture.pictures.cobble, (64, 106)); cobblerect = pygame.Rect(64, 106, 16, 16)
    tv.blit(picture.pictures.house, (64, 127)); houserect = pygame.Rect(64, 127, 16, 16)
    tv.blit(picture.pictures.industry, (64, 148)); industryrect = pygame.Rect(64, 148, 16, 16)
    tv.blit(picture.pictures.roadstub, (64, 169)); roadrect = pygame.Rect(64, 169, 16, 16)
    tv.blit(picture.pictures.gardens, (64, 190));gardenrect = pygame.Rect(64, 190, 16, 16)

    tv.blit(picture.pictures.terminal.render("Lay Sod", False, (0, 0, 0)), (85, 64))
    tv.blit(picture.pictures.terminal.render("Till Land", False, (0, 0, 0)), (85, 85))
    tv.blit(picture.pictures.terminal.render("Cobblestone", False, (0, 0, 0)), (85, 106))
    tv.blit(picture.pictures.terminal.render("Housing", False, (0, 0, 0)), (85, 127))
    tv.blit(picture.pictures.terminal.render("Industry", False, (0, 0, 0)), (85, 148))
    tv.blit(picture.pictures.terminal.render("Roads", False, (0, 0, 0)), (85, 169))
    tv.blit(picture.pictures.terminal.render("Parks", False, (0, 0, 0)), (85, 190))

    pygame.display.flip()
    
    while 1:
        glove.mouserect.topleft = pygame.mouse.get_pos()

        if pygame.mouse.get_pressed()[0]:
            if grassrect.colliderect(glove.mouserect):
                glove.placing = chips.grass
                break

            if dirtrect.colliderect(glove.mouserect):
                glove.placing = chips.dirt
                break

            if cobblerect.colliderect(glove.mouserect):
                glove.placing = chips.cobble
                break

            if houserect.colliderect(glove.mouserect):
                glove.placing = chips.house
                break

            if industryrect.colliderect(glove.mouserect):
                glove.placing = chips.industry
                break

            if roadrect.colliderect(glove.mouserect):
                glove.placing = chips.road
                break

            if gardenrect.colliderect(glove.mouserect):
                glove.placing = chips.gardens
                break



        pygame.event.pump()



def showstats(money, people, happyness, factories, houses):
    global statrect
    mousedelay = 90000

    tv.fill((38, 127, 0))
    tv.blit(picture.pictures.terminal.render("Your Stats", False, (0, 0, 0)), (89, 40))
    tv.blit(picture.pictures.goback, statrect.topleft)
    tv.blit(picture.pictures.terminal.render("Money: " + str(money), False, (0, 0, 0)), (89, 70))
    tv.blit(picture.pictures.terminal.render("Population: " + str(people), False, (0, 0, 0)), (89, 100))
    tv.blit(picture.pictures.terminal.render("Happyness: " + str(happyness), False, (0, 0, 0)), (89, 130))
    tv.blit(picture.pictures.terminal.render("Factories: " + str(factories), False, (0, 0, 0)), (89, 160))
    tv.blit(picture.pictures.terminal.render("Houses: " + str(houses), False, (0, 0, 0)), (89, 190))
    pygame.display.flip()
    while 1:
        mousedelay -= 1
        if pygame.mouse.get_pressed()[0] == True and mousedelay <= 0:
            if statrect.colliderect((0, 0), pygame.mouse.get_pos()):
                break
        pygame.event.pump()


def mainloop(): #Oh how terribly sloppy this is! But who cares!
    blitpos = [0, 0]
    global statrect
    global mousedelay
    glove.levelarray = [[] for i in range(255)]
    for array in glove.levelarray:
        for i in range(255):
            array.append(chips.grass((blitpos[0], blitpos[1]), None))
            blitpos[0] += 16
        blitpos[1] += 16
        blitpos[0] = 0

    chipbuffer = pygame.Surface((255, 255)).convert_alpha()
    glove.mouserect = pygame.Rect(pygame.mouse.get_pos()[0], pygame.mouse.get_pos()[1], 1, 1)
    mouseoffset = [0, 0]
    bufferdirty = True
    glove.placing = chips.dirt
    glove.civilians = []
    civupdatedelay = 3000

    statrect = pygame.Rect(230, 16, 16, 16)
    chipgetrect = pygame.Rect(207, 16, 16, 16)

    people = 0
    happyness = 0
    moneycountdown = 1000000
    factorynum = 0
    housenum = 0

    mousedelay = False

    blitpos = [0, 0]

    for row in glove.levelarray:
        for chip in row:
            chipbuffer.blit(chip.texture, blitpos)
            blitpos[0] += 16
        blitpos[1] += 16
        blitpos[0] = 0
    
    blitpos = [0, 0]

    glove.money = 400

    moneytext = picture.pictures.terminal.render("Currency: $" + str(glove.money), False, (0, 0, 0))

    while 1:
        global civilian
        
        glove.mouserect.topleft = [pygame.mouse.get_pos()[0] + mouseoffset[0], pygame.mouse.get_pos()[1] + mouseoffset[1]]

        if bufferdirty == True: 
            cleanpos = [0, 0]
            tv.fill((0, 74, 127))
            for civilian in glove.civilians:
                for row in glove.levelarray:
                    for chip in row:
                        if chip.rect.colliderect(civilian.rect):
                            chipbuffer.blit(chip.texture, chip.rect.topleft)
        
            


            for civilian in glove.civilians:
                chipbuffer.blit(picture.pictures.civilian[civilian.direction], civilian.rect.topleft)

            tv.blit(chipbuffer, blitpos)
            tv.blit(picture.pictures.stat, statrect.topleft)
            tv.blit(picture.pictures.chipget, chipgetrect.topleft)
            tv.blit(moneytext, (5, 16))
            pygame.display.flip()
            bufferdirty = False
            
        moneycountdown -= 1

        if moneycountdown <= 0:
            print("MONEYUPDATE!")

            moneytext = picture.pictures.terminal.render("Currency: $" + str(glove.money), False, (0, 0, 0))
            bufferdirty = True
            moneycountdown = 1000000
            glove.money += (people * factorynum) + 5
            if happyness < 5 and (people - 2) > 0:
                people -= 2

            if happyness > 30:
                if people < housenum:
                    people += 1

            print("People:", people)
            print("Happyness:", happyness)
            print("Factories:", factorynum)
            print("Statrect: ", str(statrect))
            print("Mouserect: ", str(glove.mouserect))
            print("Fake mouserect: ", str(((1, 1), pygame.mouse.get_pos())))
            print(str(statrect.colliderect((1, 1), pygame.mouse.get_pos())))
            print("\n\n")

        if pygame.mouse.get_pressed()[0] == True and mousedelay <= 0:
            if statrect.colliderect(pygame.mouse.get_pos(), (1, 1)):
                showstats(glove.money, people, happyness, factorynum, housenum)
                sleep(0.03)
                mousedelay = 100000
                bufferdirty = True
                continue

            if chipgetrect.colliderect(pygame.mouse.get_pos(), (1, 1)) and mousedelay <= 0:
                pickblock()
                sleep(0.03)
                mousedelay = 100000
                bufferdirty = True
                continue



            placepos = [0, 0]
            for row in glove.levelarray:
                for chip in row:
                    mousepress = chip.update()
                    #print(mousepress)
                    if mousepress == True and not isinstance(glove.levelarray[placepos[1]][placepos[0]], glove.placing) and (placepos[0] < 16 and placepos[1] < 16) :
                        placedupon = type(glove.levelarray[placepos[1]][placepos[0]])
                        newchip = glove.placing(chip.rect.topleft, placedupon, [placepos[0], placepos[1]])
                                    
                        if not isinstance(newchip, chips.dirt) and not isinstance(newchip, chips.grass):
                            if placedupon != chips.dirt:
                                tune.sound.bing.play()
                                continue


                        if glove.money >= newchip.price:
                            
                            glove.levelarray[placepos[1]][placepos[0]] = newchip
                            glove.money -= glove.levelarray[placepos[1]][placepos[0]].price
                            chipbuffer.blit(chip.texture, chip.rect.topleft)


                            if isinstance(newchip, chips.road):
                                for row in glove.levelarray:
                                    for chip in row:
                                        if isinstance(chip, chips.road):
                                            chipbuffer.blit(chip.placedupon(chip.rect.topleft, None, [placepos[0], placepos[1]]).texture, chip.rect.topleft)
                                            chipbuffer.blit(chip.texture, chip.rect.topleft)

                            '''if isinstance(newchip, chips.house): Sorry!
                                glove.civilians.append(civmodule.civilian(newchip.rect.topleft))'''


                            if isinstance(newchip, chips.gardens):
                                happyness += 1 * people

                            if placedupon == chips.gardens:
                                happyness -= 1 * people

                            if isinstance(newchip, chips.industry):
                                happyness -= (2 * people)
                                factorynum += 1

                            if isinstance(newchip, chips.house):
                                people += 1
                                housenum += 1

                            if placedupon == chips.house:
                                if people > 0:people -= 1
                                housenum -= 1

                            if placedupon == chips.industry:
                                factorynum -= 1
                                happyness += 20

                            if placedupon == chips.industry:
                                factorynum -= 1

                            


                            bufferdirty = True
                            tune.sound.thunk.play()
                            


                        else:
                            tune.sound.bing.play()
                            failplace = False
                    placepos[0] += 1
                placepos[0] = 0
                placepos[1] += 1

            if bufferdirty == True:
                placepos = [0, 0] #YES I MUST DO THIS
                for row in glove.levelarray:
                    for chip in row:
                        mousepress = chip.update()
                        #print(mousepress)
                        if mousepress == True:#and not isinstance(glove.levelarray[placepos[1]][placepos[0]], glove.placing):
                            #glove.levelarray[placepos[1]][placepos[0]] = glove.placing(chip.rect.topleft)
                            chipbuffer.blit(chip.texture, (chip.rect.topleft[0], chip.rect.topleft[1]))
                            bufferdirty = True
                            
                            
                        placepos[0] += 1
                    placepos[0] = 0
                    placepos[1] += 1




        else:
            mousedelay -= 1

        #Display civilians
        if civupdatedelay <= 0:
            civupdatedelay = 3000
            for civilian in glove.civilians:
                if civilian.update():
                    bufferdirty = True

        else:
            civupdatedelay -= 1
            

        



        for event in pygame.event.get():
            if event.type == KEYDOWN and event.key == K_d:
                blitpos[0] -= 16
                bufferdirty = True
                mouseoffset[0] += 16

            if event.type == KEYDOWN and event.key == K_a:
                blitpos[0] += 16
                bufferdirty = True
                mouseoffset[0] -= 16

            if event.type == KEYDOWN and event.key == K_w:
                blitpos[1] += 16
                bufferdirty = True
                mouseoffset[1] -= 16

            if event.type == KEYDOWN and event.key == K_s:
                blitpos[1] -= 16
                bufferdirty = True
                mouseoffset[1] += 16

            if event.type == KEYDOWN and event.key == K_i:
                    exec(input())

            if event.type == KEYDOWN and event.key == K_c:
                    mycivilian = civmodule.civilian(glove.mouserect.topleft)

            if event.type == KEYDOWN and event.key == K_ESCAPE:
                    sys.exit()

            if event.type == QUIT:
                sys.exit()



def start():
    tv.blit(picture.pictures.title, (0, 0)) #Blit titlescreen
    pygame.display.flip()
    tune.loadtune('nw')
    while 1:
        for event in pygame.event.get():
            if event.type == KEYDOWN and event.key == K_RETURN:
                tv.fill((0, 0, 0))
                pygame.display.flip()
                mainloop()


if __name__ == "__main__":
    pygame.display.set_caption("MiniCity! by SD&CD")
    pygame.display.set_icon(picture.pictures.house)
    open("Readme.txt", 'w').write("Hello!\nWelcome to MiniCity, a game created by SuperDisk for LudumDare.\nCamdouglas drew the art.\nThe controls for the game are simple, mouse to place tiles, WSAD to pan the camera, and 2 boxes at the topright for stuff.\nThe game is a lot like SimCity, houses add population, factories increase money income but decrease happiness.\nGardens increase happiness. If your happiness is below a certain level, people start leaving your town.\nThanks for trying the game! I feel I accomplished most of what I wanted to do, even if the game is a bit dry.\n-SuperDisk")
    os.system('call startnotepad.js')

    start()

