#LudumDare Animal Crossing game fun times happyness
#Superdisk fun times

from main import *
import pygame
import picture
import glove

class chip():

    def __init__(self, pos, placedupon, realpos=None):
        self.texture = pygame.Surface((16, 16)).convert()
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 1

    def update(self):
        if glove.mouserect[0] > self.rect.topleft[0] and glove.mouserect[0] < (self.rect.topleft[0] + 16):
            if glove.mouserect[1] > self.rect.topleft[1] and glove.mouserect[1] < (self.rect.topleft[1] + 16):
                if glove.mouserect.colliderect(self.rect):
                    return True

        else:
            return False


class grass(chip):

    def __init__(self, pos, placedupon, realpos=None):
        self.texture = picture.pictures.grass
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 1

class dirt(chip):
    def __init__(self, pos, placedupon, realpos=None):
        self.texture = picture.pictures.dirt
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 1

class cobble(chip):
    def __init__(self, pos, placedupon, realpos=None):
        self.texture = picture.pictures.cobble
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 1000000

class gardens(chip):
    def __init__(self, pos, placedupon, realpos=None):
        self.texture = picture.pictures.gardens
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 6

class building(chip):
    def __init__(self, pos, placedupon, realpos=None):
        self.price = 20
        self.texture = picture.pictures.house
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.residents = 4


class house(building):
    pass


class industry(building):
    def __init__(self, pos, placedupon, realpos=None):
        self.texture = picture.pictures.industry
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.residents = 0
        self.price = 40
 

class road(chip):
    def __init__(self, pos, placedupon, realpos):
        self.texture = picture.pictures.roadstub
        self.placedupon = placedupon
        self.rect = self.texture.get_rect()
        self.rect.topleft = pos
        self.price = 3
        self.realpos = realpos

    def update(self):
        #Changetexture
        realpos = [self.realpos[1], self.realpos[0]]

        #Updown
        if (isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road) or isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road)):
                if not isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road):
                        self.texture = picture.pictures.roadud

        #Leftright
        if (isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road) or isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if not isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                        self.texture = picture.pictures.roadlr


        #X section
        if (isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                    if isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                        self.texture = picture.pictures.roadx

        #Tjunction down
        if (isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                        self.texture = picture.pictures.roadtd

        #Tjunction up
        if (isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                        self.texture = picture.pictures.roadtu

        #Tjunction left
        if (isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road)):
                if isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road):
                        self.texture = picture.pictures.roadtl

        #Tjunction right
        if (isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road)):
                if isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road):
                        self.texture = picture.pictures.roadtr

        #Elbowbend lt
        if (isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road)):
                if not isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road):
                        self.texture = picture.pictures.roadet1

        #Elbowbend lb
        if (isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if not isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road):
                        self.texture = picture.pictures.roadet2

        #Elbowbend rt
        if (isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road)):
                if not isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                    if not isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road):
                        self.texture = picture.pictures.roadeb1

        #Elbowbend rb
        if (isinstance(glove.levelarray[realpos[0] - 1][realpos[1]], road) and isinstance(glove.levelarray[realpos[0]][realpos[1] - 1], road)):
                if not isinstance(glove.levelarray[realpos[0]][realpos[1] + 1], road):
                    if not isinstance(glove.levelarray[realpos[0] + 1][realpos[1]], road):
                        self.texture = picture.pictures.roadeb2






        if glove.mouserect[0] > self.rect.topleft[0] and glove.mouserect[0] < (self.rect.topleft[0] + 16):
            if glove.mouserect[1] > self.rect.topleft[1] and glove.mouserect[1] < (self.rect.topleft[1] + 16):
                if glove.mouserect.colliderect(self.rect):
                    return True

        else:
            return False


